## lizardfs 3.9.4+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
set(CMAKE_LEGACY_CYGWIN_WIN32 0) # Remove when CMake >= 2.8.4 is required
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_MODULE_PATH})

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR
    "In-source builds are disabled for this project. This is for your "
    "safety. To build the project, please create a build tree in "
    "a separate directory, for example:\n"
    "     mkdir ${CMAKE_SOURCE_DIR}/build\n"
    "     cd ${CMAKE_SOURCE_DIR}/build\n"
    "     cmake ..\n"
    "Before doing that you may need to clean up after this try by removing "
    "CMakeCache.txt file and CMakeFiles/ directory.\n"
    "If you REALLY need an in-source build, remove this check from "
    "${CMAKE_CURRENT_LIST_FILE} and try again."
  )
endif()

project(lizardfs)
set(PACKAGE_VERSION_MAJOR 3)
set(PACKAGE_VERSION_MINOR 9)
set(PACKAGE_VERSION_MICRO 4)
set(PACKAGE_VERSION
    "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_MICRO}")

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Debug)
endif()

set(CXX_STD c++0x)
if(CYGWIN)
  set(CXX_STD gnu++11)
endif()
if(CMAKE_SYSTEM_NAME STREQUAL "SunOS")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m64" )
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -m64")
endif()
if(MINGW)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wformat=0")
endif()
string(REPLACE "-DNDEBUG" "" CMAKE_CXX_FLAGS_RELWITHDEBINFO ${CMAKE_CXX_FLAGS_RELWITHDEBINFO})
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pipe -std=${CXX_STD} -pthread -Wall -Wextra -fwrapv")
set(CMAKE_CXX_FLAGS_DEBUG "-O0 -g")
set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3 -DNDEBUG -g")
set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -O2 -ftree-vectorize -g -fno-omit-frame-pointer")
set(CMAKE_CXX_FLAGS_COVERAGE "-O0 -g --coverage")
set(CMAKE_CXX_FLAGS_CLANG_ANALYZE "--analyze -Xanalyzer -analyzer-output=text")
set(CMAKE_CXX_FLAGS_CLANG_SANITIZE_THREAD "-g -O0 -fsanitize=thread")

add_definitions(-D_LARGEFILE_SOURCE)
add_definitions(-D_FILE_OFFSET_BITS=64)
add_definitions(-DLIZARDFS_HAVE_CONFIG_H)
add_definitions(-D__STDC_LIMIT_MACROS)
add_definitions(-D__STDC_CONSTANT_MACROS)
add_definitions(-D__STDC_FORMAT_MACROS)
if(MINGW)
  add_definitions(-DWINVER=0x0602)
  add_definitions(-D_WIN32_WINNT=0x0602)
  add_definitions(-DFD_SETSIZE=1024)
  set(MINGW_MSVCRT "msvcr110")
endif()

# XXX(lamvak): what about OS X?
set(DEFAULT_USER  "mfs" CACHE STRING "Default user to run daemons as")
set(DEFAULT_GROUP "mfs" CACHE STRING "Default group to run daemons as")
set(LIZARDFS_BLOCKS_IN_CHUNK 1024 CACHE INT "Number of blocks in one chunk")
set(LIZARDFS_BLOCK_SIZE 65536 CACHE INT "Number of bytes in one block")
option(ENABLE_WERROR        "Enable treating compilation warnings as errors"          OFF)
option(ENABLE_LIGHTMFS      "Enable light version of LizardFS"                        OFF)
option(ENABLE_DEBIAN_PATHS  "Enable Debian-style install paths"                       OFF)
option(ENABLE_UTILS         "Enable building additional binaries used e.g. in tests"  OFF)
option(ENABLE_TESTS         "Enable building unit and functional tests"               OFF)
option(ENABLE_DOCS          "Enable building the documentation"                       ON)
option(ENABLE_EXIT_ON_USR1  "Enable handler for SIGUSR1 which calls exit()"           OFF)
option(THROW_INSTEAD_OF_ABORT   "Throw std::exception instead of calling abort"       OFF)
option(ENABLE_DEBUG_LOG     "Enable prefix based debug logs"                          OFF)
option(ENABLE_VERBOSE_ASCIIDOC  "Enable verbose output of asciidoc"                   OFF)
option(ENABLE_TCMALLOC      "Enable use of tcmalloc-minimal library"                  OFF)
# end of LizardFS options
option(ENABLE_TRACES        "Enable traces"                                           OFF)
option(ENABLE_CRC           "Enable checksums"                                        ON)
option(ENABLE_REQUEST_LOG   "Enable logging request times"                            OFF)
option(USE_LEGACY_READ_MESSAGES "Enable sending old type of messages by mount"        OFF)

message(STATUS "CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")
message(STATUS "CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "DEFAULT_USER: ${DEFAULT_USER}")
message(STATUS "DEFAULT_GROUP: ${DEFAULT_GROUP}")
message(STATUS "LIZARDFS_BLOCKS_IN_CHUNK: ${LIZARDFS_BLOCKS_IN_CHUNK}")
message(STATUS "LIZARDFS_BLOCK_SIZE: ${LIZARDFS_BLOCK_SIZE}")
message(STATUS "ENABLE_WERROR: ${ENABLE_WERROR}")
message(STATUS "ENABLE_LIGHTMFS: ${ENABLE_LIGHTMFS}")
message(STATUS "ENABLE_DEBIAN_PATHS: ${ENABLE_DEBIAN_PATHS}")
message(STATUS "ENABLE_UTILS: ${ENABLE_UTILS}")
message(STATUS "ENABLE_TESTS: ${ENABLE_TESTS}")
message(STATUS "ENABLE_DOCS: ${ENABLE_DOCS}")
message(STATUS "ENABLE_EXIT_ON_USR1: ${ENABLE_EXIT_ON_USR1}")
message(STATUS "THROW_INSTEAD_OF_ABORT: ${THROW_INSTEAD_OF_ABORT}")
message(STATUS "ENABLE_DEBUG_LOG: ${ENABLE_DEBUG_LOG}")
message(STATUS "ENABLE_VERBOSE_ASCIIDOC: ${ENABLE_VERBOSE_ASCIIDOC}")
message(STATUS "ENABLE_TCMALLOC: ${ENABLE_TCMALLOC}")
# end of LizardFS options values
message(STATUS "ENABLE_TRACES: ${ENABLE_TRACES}")
message(STATUS "ENABLE_CRC: ${ENABLE_CRC}")
message(STATUS "ENABLE_REQUEST_LOG: ${ENABLE_REQUEST_LOG}")
message(STATUS "USE_LEGACY_READ_MESSAGES: ${USE_LEGACY_READ_MESSAGES}")

# All the environment tests (libs, includes, etc.) live here:
include(EnvTests.cmake)
include(Libraries)
include(GNUInstallDirs)
check_includes("${INCLUDES}")

# Disable -pedantic for old gcc because of unfounded
# "no comma at end of enumerator list" warning during crcutil compilation
execute_process(COMMAND ${CMAKE_CXX_COMPILER} -dumpversion OUTPUT_VARIABLE COMPILER_VERSION)
if(ENABLE_WERROR AND CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND COMPILER_VERSION VERSION_LESS 4.7)
  message(STATUS "Flag '-pedantic' disabled for GCC < 4.7")
else()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic")
endif()

if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Qunused-arguments")
endif()

if(CXX_HAS_WNOGNU)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-gnu")
endif()

if(ENABLE_WERROR)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
endif()

if(ENABLE_TESTS AND NOT THROW_INSTEAD_OF_ABORT)
  message(STATUS "Tests require THROW_INSTEAD_OF_ABORT to be set to YES, changing passed value:")
  set(THROW_INSTEAD_OF_ABORT YES)
  message(STATUS "THROW_INSTEAD_OF_ABORT: ${THROW_INSTEAD_OF_ABORT}")
endif()

if(ENABLE_DEBIAN_PATHS)
  if (NOT CMAKE_INSTALL_PREFIX STREQUAL "/")
    message(WARNING "Debian paths enabled, but CMAKE_INSTALL_PREFIX is different than /")
  endif()
  set(BIN_SUBDIR   "usr/bin")
  set(SBIN_SUBDIR  "usr/sbin")
  set(LIB_SUBDIR   "usr/lib")
  set(ETC_SUBDIR   "etc/mfs")
  set(RUN_SUBDIR   "var/run/mfs")
  set(DATA_SUBDIR  "var/lib/mfs")
  set(MAN_SUBDIR   "usr/share/man")
  set(CGI_SUBDIR   "usr/share/mfscgi")
else()
  set(BIN_SUBDIR   "bin")
  set(SBIN_SUBDIR  "sbin")
  set(LIB_SUBDIR   "lib")
  set(ETC_SUBDIR   "etc/mfs")
  set(RUN_SUBDIR   "var/run/mfs")
  set(DATA_SUBDIR  "var/lib/mfs")
  set(MAN_SUBDIR   "share/man")
  set(CGI_SUBDIR   "share/mfscgi")
endif()

string(REGEX REPLACE "/$" "" INSTALL_PREFIX_NO_SLASH ${CMAKE_INSTALL_PREFIX})
set(BIN_PATH   ${INSTALL_PREFIX_NO_SLASH}/${BIN_SUBDIR})
set(SBIN_PATH  ${INSTALL_PREFIX_NO_SLASH}/${SBIN_SUBDIR})
set(LIB_PATH   ${INSTALL_PREFIX_NO_SLASH}/${LIB_SUBDIR})
set(ETC_PATH   ${INSTALL_PREFIX_NO_SLASH}/${ETC_SUBDIR})
set(RUN_PATH   ${INSTALL_PREFIX_NO_SLASH}/${RUN_SUBDIR})
set(DATA_PATH  ${INSTALL_PREFIX_NO_SLASH}/${DATA_SUBDIR})
set(MAN_PATH   ${INSTALL_PREFIX_NO_SLASH}/${MAN_SUBDIR})
set(CGI_PATH   ${INSTALL_PREFIX_NO_SLASH}/${CGI_SUBDIR})

if(ENABLE_LIGHTMFS)
  set(PROTO_BASE 65536)
  set(LIGHT_MFS 1)
else()
  set(PROTO_BASE 0)
  set(LIGHT_MFS 0)
endif()

if(ENABLE_UTILS)
  set(BUILD_UTILS ON)
endif()

if(ENABLE_TESTS)
  set(BUILD_TESTS ON)
  set(BUILD_UTILS ON)
  set(LIZARDFS_ENABLE_DEBUG_LOG ON)
endif()

if(ENABLE_DEBUG_LOG)
  set(LIZARDFS_ENABLE_DEBUG_LOG ON)
endif()

if(ENABLE_TRACES)
  if(NOT Boost_INCLUDE_DIRS)
    message(FATAL_ERROR "Boost headers are required if traces are enabled")
  endif()
  add_definitions(-DENABLE_TRACES)
endif()

if(ENABLE_REQUEST_LOG)
  if(NOT Boost_IOSTREAMS_FOUND)
    message(FATAL_ERROR "Boost iostreams is required if request time logging is enabled")
  endif()
  set(ADDITIONAL_LIBS ${Boost_IOSTREAMS_LIBRARY})
  add_definitions(-DENABLE_REQUEST_LOG)
endif()

set(CHARTS_CSV_CHARTID_BASE 90000)

if(THROW_INSTEAD_OF_ABORT)
  add_definitions(-DTHROW_INSTEAD_OF_ABORT)
endif()

if(USE_LEGACY_READ_MESSAGES)
  add_definitions(-DUSE_LEGACY_READ_MESSAGES)
endif()

if(ENABLE_CRC)
  message(STATUS "CRC checksums enabled")
  add_definitions(-DENABLE_CRC)
else()
  message(STATUS "CRC checksums disabled")
endif()

set(CHARTS_CSV_CHARTID_BASE 90000)

# Create config.h file
configure_file(config.h.in config.h)
include_directories(${CMAKE_BINARY_DIR}) # Here we have generated config.h

# main.cc shared by some LizardFS applications
set(MAIN_SRC ${CMAKE_SOURCE_DIR}/src/main/main.cc)

# functions & macros
macro(collect_sources VAR_PREFIX)
  file(GLOB ${VAR_PREFIX}_TESTS *_unittest.cc)
  file(GLOB ${VAR_PREFIX}_SOURCES *.cc *.h)
  file(GLOB ${VAR_PREFIX}_MAIN main.cc)
  if(${VAR_PREFIX}_MAIN OR ${VAR_PREFIX}_TESTS)
    list(REMOVE_ITEM ${VAR_PREFIX}_SOURCES ${${VAR_PREFIX}_TESTS} ${${VAR_PREFIX}_MAIN})
  endif()
endmacro(collect_sources)

function(add_tests TESTED_LIBRARY)
  if(NOT BUILD_TESTS OR ARGC EQUAL 1)
    return()
  endif()
  list(REMOVE_AT ARGV 0)
  set(TEST_LIBRARY_NAME ${TESTED_LIBRARY}_tests)
  include_directories(${GTEST_INCLUDE_DIRS})
  add_library(${TEST_LIBRARY_NAME} ${ARGV})
  target_link_libraries(${TEST_LIBRARY_NAME} ${TESTED_LIBRARY})
  set(TMP ${TEST_LIBRARIES})
  list(APPEND TMP ${TEST_LIBRARY_NAME})
  set(TEST_LIBRARIES ${TMP} CACHE INTERNAL "" FORCE)
endfunction(add_tests)

if(ZLIB_FOUND)
  include_directories(${ZLIB_INCLUDE_DIRS})
endif()
include_directories(src) # Allow paths relative to src, eg. #include common/crc.h
link_directories( ${LINK_DIRECTORIES} ${PC_FUSE_LIBRARY_DIRS} )
add_subdirectory(external)
add_subdirectory(src/admin)
add_subdirectory(src/common)
add_subdirectory(src/protocol)
add_subdirectory(src/mount)
add_subdirectory(src/mount/polonaise)

if(NOT MINGW)
  if(BUILD_DEVTOOLS)
    add_subdirectory(src/devtools)
  endif()
  add_subdirectory(src/chunkserver)
  add_subdirectory(src/master)
  add_subdirectory(src/metadump)
  add_subdirectory(src/metalogger)
  add_subdirectory(src/metarestore)
  add_subdirectory(src/tools)
  if (FUSE_LIBRARY)
    add_subdirectory(src/mount/fuse)
  endif()
  add_subdirectory(src/data)
  add_subdirectory(src/cgi)
  if(BUILD_UTILS)
    add_subdirectory(utils)
  endif()
  if(BUILD_TESTS)
    add_subdirectory(src/unittests)
    add_subdirectory(tests)
  endif()
  if(ENABLE_DOCS)
    add_subdirectory(doc)
  endif()
endif()

=== doc/CMakeLists.txt ===
if(NOT A2X_BINARY)
  message(WARNING "Program 'a2x' not found, manpages won't be generated")
  return()
endif()

# These manpages should be generated
set(MANPAGES
    lizardfs.7          # not a source
    lizardfs-admin.8
    lizardfs-cgiserver.8
    lizardfs-probe.8    # not a source
    mfsappendchunks.1
    mfscheckfile.1
    mfsdirinfo.1
    mfsfileinfo.1
    mfsfilerepair.1
    mfsgeteattr.1
    mfsseteattr.1       # not a source
    mfsdeleattr.1       # not a source
    mfsgetgoal.1
    mfssetgoal.1        # not a source
    mfsrgetgoal.1       # not a source
    mfsrsetgoal.1       # not a source
    mfsgettrashtime.1
    mfssettrashtime.1   # not a source
    mfsrgettrashtime.1  # not a source
    mfsrsettrashtime.1  # not a source
    mfsmakesnapshot.1
    mfsmount.1
    mfsrepquota.1
    mfssetquota.1       # not a source
    mfstools.1
    globaliolimits.cfg.5
    iolimits.cfg.5
    mfschunkserver.cfg.5
    mfsexports.cfg.5
    mfsgoals.cfg.5
    mfshdd.cfg.5
    mfsmaster.cfg.5
    mfsmetalogger.cfg.5
    mfstopology.cfg.5
    mfsmetadump.8
    mfsrestoremaster.8
    moosefs.7
    mfs.7               # not a source
    mfscgiserv.8
    mfschunkserver.8
    mfsmaster.8
    mfsmetalogger.8
    mfsmetarestore.8
)

set(INSTALLED_MANPAGES)
foreach(MANPAGE ${MANPAGES})
  get_filename_component(MANPAGE_SRC ${CMAKE_CURRENT_SOURCE_DIR}/${MANPAGE}.txt ABSOLUTE)
  string(REGEX MATCH "[0-9]$" SECTION_NUMBER ${MANPAGE})
  set(GENERATED_MANPAGE_PATH ${CMAKE_CURRENT_BINARY_DIR}/${MANPAGE})
  if(ENABLE_VERBOSE_ASCIIDOC)
    set(ASCIIDOC_VERBOSE --verbose --keep-artifacts)
  else()
    set(ASCIIDOC_VERBOSE)
  endif()
  if(EXISTS ${MANPAGE_SRC})
    # Generate from the source...
    set(MANPAGE_SRC_SYMLINK ${CMAKE_CURRENT_BINARY_DIR}/${MANPAGE}.txt)
    add_custom_command(OUTPUT ${GENERATED_MANPAGE_PATH}
        COMMAND ln -s -f ${MANPAGE_SRC} ${MANPAGE_SRC_SYMLINK}
        COMMAND a2x ${ASCIIDOC_VERBOSE} -f manpage ${MANPAGE_SRC_SYMLINK}
        DEPENDS ${MANPAGE_SRC})
    # Add this file to the main target's dependencies
    set(GENERATED_MANPAGES ${GENERATED_MANPAGES} ${GENERATED_MANPAGE_PATH})
  endif()
  # Install the generated file
  install(FILES ${GENERATED_MANPAGE_PATH} DESTINATION ${MAN_SUBDIR}/man${SECTION_NUMBER})
endforeach()
add_custom_target(manpages ALL SOURCES ${GENERATED_MANPAGES})

=== external/CMakeLists.txt ===
# crcutil

if(NOT CRCUTIL_FOUND)
  if(HAVE_CRCUTIL)
    include_directories(${CRCUTIL_INCLUDE_DIRS})
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CRCUTIL_CXX_FLAGS}")
    file(GLOB CRCUTIL_SOURCES ${CRCUTIL_SOURCE_DIR}/*.cc)
    add_library(crcutil ${CRCUTIL_SOURCES})
  endif()
endif()

# GoogleTest
if(BUILD_TESTS)
  include_directories(${GTEST_INCLUDE_DIRS})
  add_subdirectory(${GTEST_NAME})
endif()

=== tests/CMakeLists.txt ===
include_directories(${GTEST_INCLUDE_DIRS})

# Create automatically generated list of test cases
add_custom_target(list_of_test_cases
  COMMAND ls ${CMAKE_CURRENT_SOURCE_DIR}/test_suites
    | xargs -IXXX echo "class XXX : public BashTestingSuite {};"
    > test_suites.h.tmp
  COMMAND ${CMAKE_COMMAND} -E copy_if_different test_suites.h.tmp test_suites.h

  COMMAND find ${CMAKE_CURRENT_SOURCE_DIR}/test_suites/ -name test_*.sh
    | sed -e "s/[.]sh$//"
    | awk -F/ "{print $(NF-1) \",\" $NF}"
    | xargs -IXXX echo "add_test_case(XXX)"
    > test_cases.h.tmp
  COMMAND ${CMAKE_COMMAND} -E copy_if_different test_cases.h.tmp test_cases.h

  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  VERBATIM)
set_source_files_properties(lizardfs-tests.cc PROPERTIES
  OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/test_cases.h
  OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/test_suites.h)

# Create constants.sh file
configure_file(set_lizardfs_constants.sh.in set_lizardfs_constants.sh)
install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/set_lizardfs_constants.sh DESTINATION ${BIN_SUBDIR})

# Build executable running all the test cases
include_directories(${CMAKE_CURRENT_BINARY_DIR}) # test_cases.h is located here
add_definitions(-DTEST_DATA_PATH=${CMAKE_CURRENT_SOURCE_DIR})
add_executable(lizardfs-tests lizardfs-tests.cc)
add_dependencies(lizardfs-tests list_of_test_cases)
target_link_libraries(lizardfs-tests gtest_main)
install(TARGETS lizardfs-tests RUNTIME DESTINATION ${BIN_SUBDIR})

=== utils/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR})

install(PROGRAMS cpp-interpreter.sh DESTINATION ${BIN_SUBDIR})

# a library which causes pread/pwrite/close on chunks to return EIO
add_library(chunk_operations_eio SHARED chunk_operations_eio.c)
target_link_libraries(chunk_operations_eio dl)
install(TARGETS chunk_operations_eio DESTINATION ${LIB_SUBDIR})

# converter to xor chunks
add_executable(chunk_converter chunk_converter.cc)
target_link_libraries(chunk_converter ${ZLIB_LIBRARY})
install(TARGETS chunk_converter RUNTIME DESTINATION ${BIN_SUBDIR})

# crc converter
add_executable(crc_converter crc_converter.cc)
target_link_libraries(crc_converter ${ZLIB_LIBRARY})
install(TARGETS crc_converter RUNTIME DESTINATION ${BIN_SUBDIR})

# redirecting bind library
add_library(redirect_bind SHARED redirect_bind.c)
target_link_libraries(redirect_bind dl)
install(TARGETS redirect_bind DESTINATION ${LIB_SUBDIR})

# test files generator
add_executable(file-generate file_generate.cc)
install(TARGETS file-generate RUNTIME DESTINATION ${BIN_SUBDIR})

# test files generator which overwrites existing files
add_executable(file-overwrite file_overwrite.cc)
install(TARGETS file-overwrite RUNTIME DESTINATION ${BIN_SUBDIR})

# test files validator
add_executable(file-validate file_validate.cc)
install(TARGETS file-validate RUNTIME DESTINATION ${BIN_SUBDIR})

# utility for flock() system call
add_executable(flockcmd flockcmd.cc)
install(TARGETS flockcmd RUNTIME DESTINATION ${BIN_SUBDIR})

# utility for posix locks
add_executable(posixlockcmd posixlockcmd.cc)
install(TARGETS posixlockcmd RUNTIME DESTINATION ${BIN_SUBDIR})

# ping client
add_executable(mfsping mfs_ping.cc)
target_link_libraries(mfsping mfscommon)
install(TARGETS mfsping RUNTIME DESTINATION ${BIN_SUBDIR})

# ping server
add_executable(mfspingserv mfs_pingserv.cc)
target_link_libraries(mfspingserv mfscommon)
install(TARGETS mfspingserv RUNTIME DESTINATION ${BIN_SUBDIR})

# ping pong fcntl lock test
add_executable(lzfs_ping_pong ping_pong.cc)
install(TARGETS lzfs_ping_pong RUNTIME DESTINATION ${BIN_SUBDIR})

=== src/chunkserver/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
add_definitions(-DLIZARDFS_MAX_FILES=10000)
add_definitions(-DAPPNAME=mfschunkserver)

collect_sources(CHUNKSERVER)
add_library(chunkserver ${CHUNKSERVER_SOURCES})
target_link_libraries(chunkserver lzfsprotocol mfscommon ${ADDITIONAL_LIBS})
add_tests(chunkserver ${CHUNKSERVER_TESTS})

add_executable(mfschunkserver ${MAIN_SRC})
target_link_libraries(mfschunkserver chunkserver ${PAM_LIBRARIES})
install(TARGETS mfschunkserver RUNTIME DESTINATION ${SBIN_SUBDIR})

=== src/data/CMakeLists.txt ===
configure_file(mfsmaster.cfg.in mfsmaster.cfg)
configure_file(mfschunkserver.cfg.in mfschunkserver.cfg)
configure_file(mfsmetalogger.cfg.in mfsmetalogger.cfg)
configure_file(postinst.in postinst)
set(POSTINST_SCRIPT ${CMAKE_CURRENT_BINARY_DIR}/postinst PARENT_SCOPE)
install(FILES metadata.mfs DESTINATION ${DATA_SUBDIR} RENAME metadata.mfs.empty)
install(FILES mfsexports.cfg DESTINATION ${ETC_SUBDIR} RENAME mfsexports.cfg.dist)
install(FILES mfsgoals.cfg DESTINATION ${ETC_SUBDIR} RENAME mfsgoals.cfg.dist)
install(FILES mfshdd.cfg DESTINATION ${ETC_SUBDIR} RENAME mfshdd.cfg.dist)
install(FILES mfsmount.cfg DESTINATION ${ETC_SUBDIR} RENAME mfsmount.cfg.dist)
install(FILES mfstopology.cfg DESTINATION ${ETC_SUBDIR} RENAME mfstopology.cfg.dist)
install(FILES globaliolimits.cfg DESTINATION ${ETC_SUBDIR} RENAME globaliolimits.cfg.dist)
install(FILES iolimits.cfg DESTINATION ${ETC_SUBDIR} RENAME iolimits.cfg.dist)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/mfsmaster.cfg DESTINATION ${ETC_SUBDIR} RENAME mfsmaster.cfg.dist)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/mfschunkserver.cfg DESTINATION ${ETC_SUBDIR} RENAME mfschunkserver.cfg.dist)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/mfsmetalogger.cfg DESTINATION ${ETC_SUBDIR} RENAME mfsmetalogger.cfg.dist)

=== src/master/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
add_definitions(-DAPPNAME=mfsmaster)

collect_sources(MASTER)

add_library(master ${MASTER_SOURCES})
target_link_libraries(master mfscommon ${ADDITIONAL_LIBS})
if(JUDY_LIBRARY)
  target_link_libraries(master ${JUDY_LIBRARY})
endif()
add_tests(master ${MASTER_TESTS})

add_executable(mfsmaster ${MAIN_SRC})
target_link_libraries(mfsmaster master ${PAM_LIBRARIES})
install(TARGETS mfsmaster RUNTIME DESTINATION ${SBIN_SUBDIR})

configure_file(mfsrestoremaster.in mfsrestoremaster @ONLY)
install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/mfsrestoremaster DESTINATION ${SBIN_SUBDIR})

=== src/metalogger/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
add_definitions(-DMETALOGGER)
add_definitions(-DAPPNAME=mfsmetalogger)

collect_sources(METALOGGER)

add_library(metalogger ${METALOGGER_SOURCES} ../master/changelog.cc ../master/masterconn.cc)
target_link_libraries(metalogger mfscommon)
add_tests(metalogger ${METALOGGER_TESTS})

add_executable(mfsmetalogger ${MAIN_SRC})
target_link_libraries(mfsmetalogger metalogger ${PAM_LIBRARIES})
install(TARGETS mfsmetalogger RUNTIME DESTINATION ${SBIN_SUBDIR})

=== src/tools/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
set(MFSTOOL_LINKS
  mfsgetgoal
  mfssetgoal
  mfsgettrashtime
  mfssettrashtime
  mfscheckfile
  mfsfileinfo
  mfsappendchunks
  mfsdirinfo
  mfsfilerepair
  mfsmakesnapshot
  mfsgeteattr
  mfsseteattr
  mfsdeleattr
  mfsrgetgoal
  mfsrsetgoal
  mfsrgettrashtime
  mfsrsettrashtime
  mfssetquota
  mfsrepquota)

collect_sources(TOOLS)

add_executable(mfstools ${TOOLS_MAIN})
target_link_libraries(mfstools mfscommon)
install(TARGETS mfstools DESTINATION ${BIN_SUBDIR})

foreach(LINK ${MFSTOOL_LINKS})
  add_custom_target(${LINK} ALL
      COMMAND ln -sf mfstools ${LINK}
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      DEPENDS mfstools)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${LINK} DESTINATION ${BIN_SUBDIR})
endforeach()

=== src/unittests/CMakeLists.txt ===
include_directories(${GTEST_INCLUDE_DIRS})

add_subdirectory(mocks)

collect_sources(UNITTESTS)
add_library(unittests-helpers ${UNITTESTS_SOURCES})
add_tests(unittests-helpers ${UNITTESTS_TESTS})

add_executable(unittests ${UNITTESTS_MAIN})
target_link_libraries(unittests gtest mfscommon master
    "-Wl,--whole-archive" ${TEST_LIBRARIES} "-Wl,--no-whole-archive"
    unittests-helpers unittest-mocks ${Boost_SYSTEM_LIBRARY} ${Boost_FILESYSTEM_LIBRARY})

=== src/mount/fuse/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

add_definitions(-DAPPNAME=mfsmount)

collect_sources(MOUNT_FUSE)

add_library(mount_fuse ${MOUNT_FUSE_SOURCES})
target_link_libraries(mount_fuse mount mfscommon)

add_definitions(-DFUSE_USE_VERSION=26)
add_definitions(${PC_FUSE_CFLAGS_OTHER})
include_directories(${FUSE_INCLUDE_DIRS})
add_executable(mfsmount ${MOUNT_FUSE_MAIN})
target_link_libraries(mfsmount mount_fuse ${FUSE_LIBRARY})
install(TARGETS mfsmount RUNTIME DESTINATION ${BIN_SUBDIR})

=== debian/changelog ===
lizardfs (3.9.4+dfsg-4) unstable; urgency=medium

  * New upstream patches.
  * chunkserver: disable USE_SPLICE by default due to read errors.
  * client: global file locking is disabled by default.
  * Improved/reviewed "fix-FTBFS-kfreebsd.patch".
  * Build with PIE hardeng (hardening-no-pie).
  * Corrected "spelling-error-in-description".
  * Updated Vcs URLs (vcs-field-uses-insecure-uri).

 -- Dmitry Smirnov <onlyjob@debian.org>  Tue, 16 Feb 2016 12:01:08 +1100

lizardfs (3.9.4+dfsg-3) unstable; urgency=medium

  * Upload to unstable.
  * Added NEWS file with 2.6.0 to 3.9.4 upgrade instructions.
  * New "3.9.5~chunkserver_deny-replication-during-scan.patch".

 -- Dmitry Smirnov <onlyjob@debian.org>  Tue, 05 Jan 2016 05:07:43 +1100

lizardfs (3.9.4+dfsg-2) experimental; urgency=medium

  * New patches:
    + 3.9.5~common-exception.patch
    + cgi-unquote-messages.patch
    + fix-FTBFS-cmake-3.4.patch (Closes: #809584).
    + fix-FTBFS-kfreebsd.patch
    + fix-FTBFS-powerpc.patch
    + systemd-notify.patch
  * Systemd: set "Type=notify" for services.
  * Build-Depends: restrict "libboost-all-dev" to "amd64".

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 20 Dec 2015 12:39:22 +1100

lizardfs (3.9.4+dfsg-1) experimental; urgency=low

  * New upstream release [December 2015].
  * Build-Depends:
    + libjudy-dev
    + libpam-dev
    + libboost-all-dev
  * Removed obsolete patches:
    - system-crcutil.patch
    - upstream-mman.patch
    - upstream-rlimit.patch
  * New "default-faster-close.patch" to close opened file handles faster.
  * Link with "-latomic" on hppa.
  * Build with "-DENABLE_TCMALLOC=NO" to avoid performance degradation.
  * Install udev rule to hide lizardfs devices from udisks.
  * chunkserver.init: Should-Start += "$named".
  * systemd: added "OOMScoreAdjust=-999" to "master" and "chunkserver"
    .service files.

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 10 Dec 2015 02:58:16 +1100

=== debian/control ===
Source: lizardfs
Section: admin
Priority: optional
Maintainer: Dmitry Smirnov <onlyjob@debian.org>
Build-Depends: debhelper (>= 9), dh-python, dh-systemd
              ,python-all
              ,cmake
              ,asciidoc
                  ,libxml2-utils
                  ,docbook-xml
                  ,docbook-xsl
                  ,xsltproc
              ,pkg-config
# libcrcutil is for little-endian architectures only.
              ,libcrcutil-dev [!hppa !m68k !mips !powerpc !powerpcspe !ppc64 !s390 !s390x !sparc !sparc64]
              ,libfuse-dev (>= 2.9.0)
#_beware:     ,libgoogle-perftools-dev
              ,libgtest-dev
              ,libjudy-dev
              ,libpam-dev
              ,libsystemd-dev [!kfreebsd-any]
#             ,libthrift-dev
              ,zlib1g-dev
# -DENABLE_TESTS=YES requirements:
             ,libboost-all-dev [amd64]
Standards-Version: 3.9.6
X-Python-Version: >= 2.7 << 3.0
Homepage: http://lizardfs.org/
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/lizardfs.git
Vcs-Git: https://anonscm.debian.org/collab-maint/lizardfs.git

Package: lizardfs-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
        ,adduser
Description: LizardFS - common files
 Files and services common for all LizardFS daemons.
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-master
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
        ,lizardfs-common (>= ${source:Version})
Description: LizardFS - master server
 LizardFS master (metadata) server.
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-metalogger
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
        ,lizardfs-common (>= ${source:Version})
Description: LizardFS - metalogger server
 LizardFS metadata replication (backup) server.
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-chunkserver
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
        ,lizardfs-common (>= ${source:Version})
Description: LizardFS - data server
 The LizardFS data server.
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-client
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: LizardFS - client tools and mount utility
 LizardFS FUSE mount utility "mfsmount" and client tool "mfstools".
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-adm
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: LizardFS - administration tools
 LizardFS administration tool: lizardfs-probe
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-cgi
Architecture: all
Depends: ${misc:Depends}, ${python:Depends}
        ,python
Description: LizardFS - CGI monitor
 CGI application to monitor LizardFS through master/metadata server.
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-cgiserv
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
        ,lizardfs-cgi
        ,lizardfs-common (>= ${source:Version})
        ,${python:Depends}
Description: simple CGI-capable HTTP server to run LizardFS CGI monitor
 Simple standalone CGI-capable HTTP server to run LizardFS CGI Monitor.
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${misc:Depends}
        ,lizardfs-master (= ${binary:Version}) | lizardfs-metalogger (= ${binary:Version}) | lizardfs-chunkserver (= ${binary:Version})
Description: Debugging symbols for LizardFS
 Debugging symbols for all LizardFS binaries
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

#Package: lizardfs-tests
#Built-Using: ${my:Built-Using}
#Architecture: any
#Depends: ${shlibs:Depends}, ${misc:Depends}
#        ,lizardfs-common (>= ${source:Version})
#        ,lizardfs-chunkserver (>= ${source:Version})
#        ,lizardfs-master (>= ${source:Version})
#        ,lizardfs-client (>= ${source:Version})
#        ,lizardfs-adm (>= ${source:Version})
#        ,attr
#        ,dbench
#        ,fuse
#        ,netcat-openbsd
#        ,socat
#        ,sudo
#        ,valgrind
#Description: LizardFS - tests suite
# The LizardFS test suite.
# .
# LizardFS is a reliable, scalable and efficient distributed file system. It
# spreads data over a number of physical servers, making it visible to an
# end user as a single file system.
# .
# Functions such as data replication, checksums, instant snapshots and easy
# connection of additional servers make LizardFS a perfect solution for
# users who need fault-proof storage ready for future expansion.
# LizardFS features include:
#  * High availbility.
#  * Quotas.
#  * POSIX Access Control Lists and POSIX Extended Attributes.
#  * I/O bandwidth limiting.
# .
# LizardFS can be used whenever one needs to store large quantities of data
# in a secure way and process them swiftly.
# LizardFS is a fork of MooseFS.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

## fix FTBFS@ppc64: https://github.com/lizardfs/lizardfs/issues/249
ifneq (,$(filter $(DEB_HOST_ARCH),mips mipsel powerpc powerpcspe sparc hppa))
DEB_LDFLAGS_MAINT_APPEND = -latomic
endif

# minimise needless linking
export DEB_LDFLAGS_MAINT_APPEND += -Wl,--as-needed

## Build tests only on amd64, see https://github.com/lizardfs/lizardfs/issues/197
ifeq ($(DEB_HOST_ARCH),amd64)
OPTARGS = -DENABLE_TESTS=YES
endif

%:
	dh $@ --buildsystem=cmake --builddirectory=build --parallel --with systemd,python2

override_dh_auto_clean:
	$(RM) -rv external/gtest
	dh_auto_clean

override_dh_auto_configure:
	## copy gtest sources
	cp -Rv /usr/src/gtest external/
	dh_auto_configure -- $(OPTARGS)    \
               -DCMAKE_BUILD_TYPE=Release   \
               -DCMAKE_INSTALL_PREFIX="/"   \
               -DCMAKE_VERBOSE_MAKEFILE=ON  \
               -DENABLE_VERBOSE_ASCIIDOC=ON \
               -DENABLE_DEBIAN_PATHS=YES    \
               -DENABLE_TCMALLOC=NO         \
               -DENABLE_UTILS=YES

override_dh_auto_install:
	dh_auto_install
	## rename config files
	for i in debian/tmp/etc/lizardfs/*.cfg.dist; do \
	    mv -n -v "$$i" "$${i%%.dist}"          \
	;done

override_dh_python2:
	dh_python2
	dh_python2 /usr/share/mfscgi

override_dh_gencontrol:
	dh_gencontrol -- -Vmy:Built-Using="$(foreach pkg,libgtest-dev,$(word 2,$(shell dpkg --status $(pkg) | grep Source)) (=$(word 2,$(shell dpkg --status $(pkg) | grep Version))),)"

override_dh_compress:
	## See #781131
	dh_compress --exclude="examples/mfsexports.cfg" --exclude="examples/mfsmaster.cfg"

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_installinit:
	dh_installinit --no-start

override_dh_systemd_start:
	dh_systemd_start --no-start

override_dh_systemd_enable:
	dh_systemd_enable --no-enable

override_dh_strip:
	dh_strip --dbg-package=lizardfs-dbg

=== debian/watch ===
# uscan(1) configuration file.
version=3

opts=\
repacksuffix=+dfsg,\
dversionmangle=s{\+dfsg\d*}{},\
uversionmangle=s{\-(\d+)\Z}{.$1},\
 https://github.com/lizardfs/lizardfs/releases \
 .*/archive/v?\.?(\d[-\d\.]+)\.tar\.gz
